src/Entity/Product.php
<?php

namespace App\Entity;

use App\Repository\ProductRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Gedmo\Mapping\Annotation as Gedmo;
use Gedmo\Timestampable\Traits\TimestampableEntity;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @ORM\Entity(repositoryClass=ProductRepository::class)
 */
class Product
{
    use TimestampableEntity;

    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\NotBlank(message="Type product title")
     */
    private $title;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\NotBlank(message="Type product price")
     */
    private $price;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $discount = 0;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\NotBlank(message="Type your final price")
     */
    private $finalPrice;

    /**
     * @ORM\Column(type="text", nullable=true)
     * @Assert\NotBlank(message="Type a little about product")
     */
    private $description;

    /**
     * @ORM\Column(type="string", length=255, unique=true)
     * @Gedmo\Slug(fields={"title"})
     */
    private $slug;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $image;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $slider;

    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    private $views = 0;

    /**
     * @ORM\ManyToOne(targetEntity=Category::class, inversedBy="products")
     * @ORM\JoinColumn(nullable=false)
     */
    private $category;

    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    private $stock;

    /**
     * @ORM\OneToMany(targetEntity=Order::class, mappedBy="product")
     */
    private $orders;

    /**
     * @ORM\OneToMany(targetEntity=Comment::class, mappedBy="product", orphanRemoval=true, fetch="EXTRA_LAZY")
     */
    private $comments;

    public function __construct()
    {
        $this->orders = new ArrayCollection();
        $this->comments = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getTitle(): ?string
    {
        return $this->title;
    }

    public function setTitle(?string $title): self
    {
        $this->title = $title;

        return $this;
    }

    public function getPrice(): ?float
    {
        return $this->price;
    }

    public function setPrice(string $price): self
    {
        $this->price = $price;

        return $this;
    }

    public function getDiscount(): ?int
    {
        return $this->discount;
    }

    public function setDiscount(?string $discount): self
    {
        $this->discount = $discount;

        return $this;
    }

    public function getFinalPrice(): ?float
    {
        return $this->finalPrice;
    }

    public function setFinalPrice(string $finalPrice): self
    {
        $this->finalPrice = $finalPrice;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(?string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getSlug(): ?string
    {
        return $this->slug;
    }

    public function setSlug(string $slug): self
    {
        $this->slug = $slug;

        return $this;
    }

    public function getImage(): ?string
    {
        return $this->image;
    }

    public function setImage(?string $image): self
    {
        $this->image = $image;

        return $this;
    }

    public function getSlider(): ?string
    {
        return $this->slider;
    }

    public function setSlider(?string $slider): self
    {
        $this->slider = $slider;

        return $this;
    }

    public function getViews(): ?int
    {
        return $this->views;
    }

    public function setViews(?int $views): self
    {
        $this->views = $views;

        return $this;
    }

    public function getCategory(): ?Category
    {
        return $this->category;
    }

    public function setCategory(?Category $category): self
    {
        $this->category = $category;

        return $this;
    }

    public function getImagePath(){

        return 'uploads/' . $this->image;
    }

    public function getSliderPath(){

        return 'uploads/' . $this->slider;
    }

    public function getStock(): ?int
    {
        return $this->stock;
    }

    public function setStock(?int $stock): self
    {
        $this->stock = $stock;

        return $this;
    }

    /**
     * @return Collection|Order[]
     */
    public function getOrders(): Collection
    {
        return $this->orders;
    }

    public function addOrder(Order $order): self
    {
        if (!$this->orders->contains($order)) {
            $this->orders[] = $order;
            $order->setProduct($this);
        }

        return $this;
    }

    public function removeOrder(Order $order): self
    {
        if ($this->orders->removeElement($order)) {
            // set the owning side to null (unless already changed)
            if ($order->getProduct() === $this) {
                $order->setProduct(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Comment[]
     */
    public function getComments(): Collection
    {
        return $this->comments;
    }

    public function addComment(Comment $comment): self
    {
        if (!$this->comments->contains($comment)) {
            $this->comments[] = $comment;
            $comment->setProduct($this);
        }

        return $this;
    }

    public function removeComment(Comment $comment): self
    {
        if ($this->comments->removeElement($comment)) {
            // set the owning side to null (unless already changed)
            if ($comment->getProduct() === $this) {
                $comment->setProduct(null);
            }
        }

        return $this;
    }
}

src/Entity/User.php
<?php

namespace App\Entity;

use App\Repository\UserRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Symfony\Component\Security\Core\User\UserInterface;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @ORM\Entity(repositoryClass=UserRepository::class)
 * @UniqueEntity(fields={"email"}, message="There is already an account with this email")
 */
class User implements UserInterface
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\NotBlank(message="Please enter your First name")
     * @Assert\Length(min="2",max="100")
     */
    private $firstName;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\NotBlank(message="Please enter your Last name")
     * @Assert\Length(min="2",max="100")
     */
    private $lastName;

    /**
     * @ORM\Column(type="string", length=255, unique=true)
     * @Assert\NotBlank(message="Please enter your Email")
     * @Assert\Email
     * @Assert\Length(max=150)
     */
    private $email;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $password;

    /**
     * @ORM\Column(type="date", nullable=true)
     */
    private $birthday;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     * @Assert\Length(min="20",max="200")
     */
    private $address;

    /**
     * @ORM\Column(type="integer", nullable=true)
     * @Assert\Length(min="10",max="10")
     */
    private $postCode;

    /**
     * @ORM\Column(type="json", nullable=true)
     */
    private $roles = [];

    /**
     * @ORM\OneToMany(targetEntity=Factor::class, mappedBy="user")
     */
    private $factors;

    /**
     * @ORM\OneToMany(targetEntity=Order::class, mappedBy="user")
     */
    private $orders;

    /**
     * @ORM\OneToMany(targetEntity=Comment::class, mappedBy="user", orphanRemoval=true)
     */
    private $comments;

    public function __construct()
    {
        $this->factors = new ArrayCollection();
        $this->orders = new ArrayCollection();
        $this->comments = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getFirstName(): ?string
    {
        return $this->firstName;
    }

    public function setFirstName(string $firstName): self
    {
        $this->firstName = $firstName;

        return $this;
    }

    public function getLastName(): ?string
    {
        return $this->lastName;
    }

    public function setLastName(string $lastName): self
    {
        $this->lastName = $lastName;

        return $this;
    }

    public function getEmail(): ?string
    {
        return $this->email;
    }

    public function setEmail(string $email): self
    {
        $this->email = $email;

        return $this;
    }

    public function getPassword(): ?string
    {
        return $this->password;
    }

    public function setPassword(string $password): self
    {
        $this->password = $password;

        return $this;
    }

    public function getBirthday(): ?\DateTimeInterface
    {
        return $this->birthday;
    }

    public function setBirthday(?\DateTimeInterface $birthday): self
    {
        $this->birthday = $birthday;

        return $this;
    }

    public function getAddress(): ?string
    {
        return $this->address;
    }

    public function setAddress(?string $address): self
    {
        $this->address = $address;

        return $this;
    }

    public function getPostCode(): ?int
    {
        return $this->postCode;
    }

    public function setPostCode(?int $postCode): self
    {
        $this->postCode = $postCode;

        return $this;
    }

    public function getRoles(): ?array
    {
        $roles = $this->roles;
        // guarantee every user at least has ROLE_USER
        $roles[] = 'ROLE_USER';

        return array_unique($roles);
    }

    public function setRoles(?array $roles): self
    {
        $this->roles = $roles;

        return $this;
    }

    public function getSalt()
    {
        // not needed for apps that do not check user passwords
    }

    public function getUsername()
    {
        return (string) $this->email;
    }

    public function eraseCredentials()
    {
        // If you store any temporary, sensitive data on the user, clear it here
        // $this->plainPassword = null;
    }

    public function getFullName()
    {
        return $this->getFirstName() . " " . $this->getLastName();
    }

    /**
     * @return Collection|Factor[]
     */
    public function getFactors(): Collection
    {
        return $this->factors;
    }

    public function addFactor(Factor $factor): self
    {
        if (!$this->factors->contains($factor)) {
            $this->factors[] = $factor;
            $factor->setUser($this);
        }

        return $this;
    }

    public function removeFactor(Factor $factor): self
    {
        if ($this->factors->removeElement($factor)) {
            // set the owning side to null (unless already changed)
            if ($factor->getUser() === $this) {
                $factor->setUser(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Order[]
     */
    public function getOrders(): Collection
    {
        return $this->orders;
    }

    public function addOrder(Order $order): self
    {
        if (!$this->orders->contains($order)) {
            $this->orders[] = $order;
            $order->setUser($this);
        }

        return $this;
    }

    public function removeOrder(Order $order): self
    {
        if ($this->orders->removeElement($order)) {
            // set the owning side to null (unless already changed)
            if ($order->getUser() === $this) {
                $order->setUser(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Comment[]
     */
    public function getComments(): Collection
    {
        return $this->comments;
    }

    public function addComment(Comment $comment): self
    {
        if (!$this->comments->contains($comment)) {
            $this->comments[] = $comment;
            $comment->setUser($this);
        }

        return $this;
    }

    public function removeComment(Comment $comment): self
    {
        if ($this->comments->removeElement($comment)) {
            // set the owning side to null (unless already changed)
            if ($comment->getUser() === $this) {
                $comment->setUser(null);
            }
        }

        return $this;
    }
}

templates/layouts/_products.html.twig
<div class="col-lg-4 col-md-6 col-12">
    <div class="product-wrapper mb-35">
        <div class="product-img">
            <a href="{{ path('app_product_show',{'slug':product.slug}) }}">
                <img alt="{{ product.title }}" src="{{ asset(product.imagePath) }}">
            </a>
            <div class="rating-box">
                {{ product.category.title }}
            </div>
        </div>
        <div class="product-content text-center">
            <h4><a href="{{ path('app_product_show',{'slug':product.slug}) }}">{{ product.title }}</a></h4>
            <div class="product-price-2">
                <div class="price-box">
                    {% if product.price != product.finalPrice %}
                        <del><span class="amount"><span class="Price-currencySymbol">$</span> <span class="money">{{ product.price }}</span> </span></del>
                    {% endif %}
                    <ins><span class="amount"><span class="Price-currencySymbol">$</span><span class="money">{{ product.finalPrice }}</span></span></ins>
                </div>
            </div>
        </div>
    </div>
</div>

templates/layouts/custom_form_row.html.twig
{%- block form_row -%}
    {%- set widget_attr = {} -%}
    {%- if help is not empty -%}
        {%- set widget_attr = {attr: {'aria-describedby': id ~"_help"}} -%}
    {%- endif -%}
    <div{% with {attr: {class: 'form-fild'}} %}{{ block('attributes') }}{% endwith %}>
        <p>
            {{- form_label(form) -}} {%- if required -%}<span class="required"> *</span>{%- endif -%}
        </p>
        {#        {{- form_errors(form) -}}#}
        {{- form_widget(form, widget_attr) -}}
        {{- form_help(form) -}}
    </div>
{%- endblock form_row -%}

templates/layouts/footer.html.twig
<footer class="footer-color">
    <div class="footer-container">
        <!--Footer Top Area Start-->
        <div class="footer-top-area fotter_style_hm_6 ptb-90 text-center">
            <div class="container">
                <div class="row">
                    <div class="col-lg-10 offset-lg-1 col-12">
                        <!--Footer Logo Start-->
                        <div class="footer-logo">
                            <a href="{{ path('app_home_index') }}">
                                <img alt="Benco" src="assets/img/logo/logo-white-1.png">
                            </a>
                        </div>
                        <!--Footer Logo End-->
                        <!--Footer Nav Start-->
                        <div class="footer-nav footer-nav-style-two">
                            <nav>
                                <ul>
                                    <li>
                                        <a href="{{ path('app_home_index') }}">Home</a>
                                    </li>
                                    <li>
                                        <a href="{{ path('app_product_index') }}">Shop</a>
                                    </li>
                                </ul>
                            </nav>
                        </div>
                        <!--Footer Nav End-->
                    </div>
                </div>
            </div>
        </div>

        <!--Footer Top Area End-->
        <!--Footer Bottom Area Start-->
        <div class="footer-bottom-area">
            <div class="container text-center">
                <p>&copy; Copyright bugloos All Rights Reserved</p>
            </div>
        </div>
        <!--Footer Bottom Area End-->
    </div>
</footer>

templates/layouts/header.html.twig
<header>
    <div class="header-topbar header-topbar-style-1">
        <div class="container-fluid">
            <div class="row">
                <div class="col-md-6 col-xs-12">
                    <div class="header-top-left">
                        <ul>
                            {% if app.user %}
                                <li>
                                    Welcome back {{ app.user.fullName }}
                                </li>
                            {% else %}
                                <li>
                                    <a href="{{ path('app_login') }}">Login</a>
                                </li>
                                <li>
                                    <a href="{{ path('app_register') }}">Register</a>
                                </li>
                            {% endif %}
                        </ul>
                    </div>
                </div>
                {% if app.user %}
                    <div class="col-md-6  col-xs-12 ">
                        <div class="header-top-right">
                            <ul>
                                <li>
                                    <div class="switcher menu_page my_acc">
                                        <ul>
                                            <li class="switcher-menu-active">
                                                <a href="{{ path('app_user_dashboard') }}">Profile Menu</a>
                                                <ul class="switcher__menus">
                                                    <li class="switcher-menu-item">
                                                        <a href="{{ path('app_user_dashboard') }}">Dashboard</a>
                                                    </li>
                                                    <li class="switcher-menu-item">
                                                        <a href="{{ path('app_user_factors') }}">Factors</a>
                                                    </li>
                                                    <li class="switcher-menu-item">
                                                        <a href="{{ path('app_user_profile') }}">Account details</a>
                                                    </li>
                                                    <li class="switcher-menu-item">
                                                        <a href="{{ path('app_logout') }}">Logout</a>
                                                    </li>
                                                </ul>
                                            </li>
                                        </ul>
                                    </div>
                                </li>
                            </ul>
                        </div>
                    </div>
                {% endif %}
            </div>
        </div>
    </div>

    <div class="header_area hdr_1">
        <div class="container-fluid">
            <div class="row">
                <div class="col-md-2 col-xs-12">
                    <div class="logo_area">
                        <a href="{{ path('app_home_index') }}">
                            <img src="assets/img/logo/logo.png" alt="Benco">
                        </a>
                    </div>
                </div>
                <div class="col-md-8 col-xs-12">
                    <div class="main_menu_area">
                        <div class="main-menu">
                            <nav>
                                <ul>
                                    <li {% if app.request.get('_route') == 'app_home_index' %} class="active" {% endif %}><a href="{{ path("app_home_index") }}">Home</a></li>

                                    <li {% if app.request.get('_route') == 'app_product_index' %} class="active" {% endif %}><a href="{{ path('app_product_index') }}">Shop</a></li>

                                    {% if is_granted("ROLE_ADMIN") %}
                                        <li><a href="#">ADMIN <i class="ion-ios-arrow-down"></i></a>
                                            <ul class="mega-menu">
                                                <li>
                                                    <ul>
                                                        <li class="mega-menu-title">Product</li>
                                                        <li><a href="{{ path('admin_product_index') }}"> List of product</a></li>
                                                        <li><a href="{{ path('admin_product_create') }}"> Create product</a></li>
                                                    </ul>
                                                </li>
                                                <li>
                                                    <ul>
                                                        <li class="mega-menu-title">Category</li>
                                                        <li><a href="{{ path('admin_category_index') }}"> List of category</a></li>
                                                        <li><a href="{{ path('admin_category_create') }}"> Create category</a></li>
                                                    </ul>
                                                </li>
                                            </ul>
                                        </li>
                                    {% endif %}
                                </ul>
                            </nav>
                        </div>
                    </div>
                </div>
                <div class="col-md-2 col-xs-12">
                    <div class="header-site-icon">

                        {% if app.user %}
                        <div class="header-cart same-style">
                            <div class="sidebar-trigger">
                                <ul>
                                    <li>
                                        <a href="{{ path('app_cart_order') }}">
                                            <i class="zmdi zmdi-shopping-cart-plus"></i>
                                            {% if globalOrders %}
                                            <span class="count-style">{{ globalOrders|length }}</span>
                                            {% endif %}
                                        </a>

                                        {% if globalOrders %}
                                            <ul class="ht-dropdown main-cart-box">
                                                <li class="with_scroll">

                                                    {% set globalTotalPrice = 0 %}
                                                    {% for order in globalOrders %}
                                                        <div class="single-cart-box">
                                                            <div class="cart-img">
                                                                <a href="{{ path('app_product_show',{'slug':order.product.slug}) }}">
                                                                    <img src="{{ asset(order.product.imagePath) }}" alt="{{ order.product.title }}" width="100">
                                                                </a>
                                                            </div>
                                                            <div class="cart-content">
                                                                <h6>
                                                                    <a href="{{ path('app_product_show',{'slug':order.product.slug}) }}">{{ order.product.title }}</a>
                                                                </h6>
                                                                <span class="quantitys">{{ order.product.category.title }}</span>
                                                                <span>$<span class="money">{{ order.finalPrice }}</span></span>
                                                            </div>
                                                        </div>
                                                        {% set globalTotalPrice = globalTotalPrice + order.finalPrice %}
                                                    {% endfor %}

                                                </li>
                                                <li>
                                                    <!-- Cart Footer Inner Start -->
                                                    <div class="cart-footer fix">
                                                        <h5>Subtotal :
                                                            <span class="f-right">$<span class="money">{{ globalTotalPrice }}</span></span>
                                                        </h5>
                                                        <div class="cart-actions">
                                                            <a href="{{ path('app_cart_order') }}" class="checkout">View cart</a>
                                                            <a href="{{ path('app_cart_checkout') }}" class="checkout">Checkout</a>
                                                        </div>
                                                    </div>
                                                    <!-- Cart Footer Inner End -->
                                                </li>
                                            </ul>
                                        {% endif %}
                                    </li>
                                </ul>
                            </div>
                        </div>
                        {% endif %}


                    </div>
                </div>

                <div class="mobile-menu-area ">
                    <div class="mobile-menu">
                        <nav id="mobile-menu-active">
                            <ul class="menu-overflow">
                                <li class="active"><a href="#">home <i class="ion-ios-arrow-down"></i></a>
                                    <ul>
                                        <li><a href="index.html">home version 1</a></li>
                                        <li><a href="index-2.html">home version 2</a></li>
                                        <li><a href="index-3.html">home version 3</a></li>
                                        <li><a href="index-4.html">home version 4</a></li>
                                        <li><a href="index-5.html">home version 5</a></li>
                                        <li><a href="index-6.html">home version 6</a></li>
                                    </ul>
                                </li>

                                <li><a href="about-us.html">about us </a></li>

                                <li><a href="shop.html">Shop</a></li>

                                <li><a href="blog.html">blog</a></li>

                                <li><a href="#">Features <i class="ion-ios-arrow-down"></i></a>
                                    <ul>
                                        <li><a href="portfolio.html"> portfolio</a></li>
                                        <li><a href="service.html"> service One</a></li>
                                        <li><a href="service-2.html"> service Two</a></li>
                                        <li><a href="faq.html"> FAQ Page</a></li>
                                        <li><a href="404.html"> 404 Error </a></li>
                                        <li><a href="single-blog.html"> single blog</a></li>
                                        <li><a href="cart.html"> cart page</a></li>
                                        <li><a href="checkout.html"> Checkout Page</a></li>
                                        <li><a href="login-register.html"> login register</a></li>
                                        <li><a href="my-account.html"> my account Page</a></li>
                                        <li><a href="wishlist.html"> wishlist Page</a></li>
                                        <li><a href="product-details.html"> product details </a></li>
                                    </ul>
                                </li>

                                <li><a href="contact.html">contact us</a></li>
                            </ul>
                        </nav>
                    </div>
                </div>

            </div>
        </div>
    </div>
</header>

templates/layouts/slider.html.twig
<div class="slider-area slider_s_2">
    <div class="slider-active owl-carousel">

        {% for product in sliderProducts %}
            <div class="single-slider slider-1 gray-bg" style="background-image: url({{ asset(product.sliderPath) }})">
                <div class="container">
                    <div class="row">
                        <div class="col-md-6">
                            <div class="slider-content slider-animated-1">
                                <h2 class="animated">{{ product.title }}</h2>
                                <p class="animated">{{ product.description|truncate(150) }}</p>
                                <a class="slider-btn animated" href="{{ path('app_product_show',{'slug':product.slug}) }}">shop now</a>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        {% endfor %}

    </div>
</div>